/* GLCD functions.h ------------------------------------------------*/

#ifndef __GLCD_FUNCTIONS__
#define __GLCD_FUNCTIONS__

#include <Arduino.h>

class glcd {

private: 
   uint8_t glcd_address;
  
public:
  glcd(uint8_t address);
  void clear_screen(void);
  void glcd_on(void);
  void glcd_off(void);
  void dim_on(void);
  void dim_off(void);
  void set_light(uint8_t light_level);
  void set_pixel(uint8_t x, uint8_t y, uint8_t mode);
  void draw_udec(uint16_t number, uint8_t spaces, uint8_t decimal_places);
  void draw_sdec(uint16_t number, uint8_t spaces, uint8_t decimal_places);
  void draw_char(char c);
  void set_cursor(uint8_t x, uint8_t y); 
  void draw_line(uint8_t x_start, uint8_t y_start, uint8_t x_end, uint8_t y_end, uint8_t mode); 
  void draw_rectangle(uint8_t x_start, uint8_t y_start, uint8_t x_end, uint8_t y_end, uint8_t mode);
  void draw_filled_rectangle(uint8_t x_start, uint8_t y_start, uint8_t x_end, uint8_t y_end, uint8_t mode);
  void draw_str(const char my_str[]);
  void draw_pgm_str(const char my_str[]);
  void draw_center_str(const char my_str[]);
  void draw_center_pgm_str(const char my_str[]);
  void draw_radj_str(char my_str[]);
  void draw_radj_pgm_str(char my_str[]);
  void set_font(uint8_t font);
  void draw_dotted_ver_line(uint8_t x_pos, uint8_t y_start, uint8_t y_end, uint8_t spaces, uint8_t mode);
  void draw_dotted_hor_line(uint8_t y_pos, uint8_t x_start, uint8_t x_end, uint8_t spaces, uint8_t mode);
  void draw_circle(uint8_t x_org, uint8_t y_org, uint8_t radius, uint8_t segment, uint8_t mode);
  void draw_filled_circle(uint8_t x_org, uint8_t y_org, uint8_t radius, uint8_t segment, uint8_t mode);
  void draw_function(uint8_t count, uint8_t x_start, uint8_t mode, uint8_t y_data[]);
  void draw_scatter(uint8_t count, uint8_t x_start, uint8_t mode, uint8_t y_data[]);
  void auto_scroll_off(void);
  void auto_scroll_on(void);
  uint8_t get_str_width(char str[]);
  void get_max_xy(uint8_t *x_max, uint8_t *y_max);
  void get_cursor(uint8_t *x_cur, uint8_t *y_cur);
  uint8_t get_font(void);
  uint8_t get_font_height(void);
};

#endif
